]> git.ipfire.org Git - people/stevee/network.git/blame - functions.util
6rd: Add documentation.
[people/stevee/network.git] / functions.util
CommitLineData
1848564d
MT
1#!/bin/bash
2###############################################################################
3# #
4# IPFire.org - A linux based firewall #
5# Copyright (C) 2010 Michael Tremer & Christian Schmidt #
6# #
7# This program is free software: you can redistribute it and/or modify #
8# it under the terms of the GNU General Public License as published by #
9# the Free Software Foundation, either version 3 of the License, or #
10# (at your option) any later version. #
11# #
12# This program is distributed in the hope that it will be useful, #
13# but WITHOUT ANY WARRANTY; without even the implied warranty of #
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
15# GNU General Public License for more details. #
16# #
17# You should have received a copy of the GNU General Public License #
18# along with this program. If not, see <http://www.gnu.org/licenses/>. #
19# #
20###############################################################################
21
97cb552e
MT
22# A simple print statement
23function print() {
acc9efd5
MT
24 local fmt=${1}; shift
25
40e3553f 26 printf -- "${fmt}\n" "$@"
97cb552e
MT
27}
28
cb965348
MT
29# The args() function takes a number of arguments like
30# var1="abc d" var2="abc" var3="abcd e"
31# and splits them into several arguments, devided by newline
32function args() {
33 echo "$@" | xargs printf "%s\n"
34}
35
04854c77
MT
36function unquote() {
37 local var="$@"
38
39 if [ "${var:0:1}" = "\"" ]; then
40 var=${var:1}
41 fi
42
43 local last=$(( ${#var} - 1 ))
44 if [ ${last} -ge 0 ] && [ "${var:${last}:1}" = "\"" ]; then
45 var=${var:0:${last}}
46 fi
47
48 print "${var}"
49}
50
51function quote() {
52 print "\"%s\"" "$@"
53}
54
fe52c5e0
MT
55function strip() {
56 local value="$@"
57
58 # remove leading whitespace characters
59 value="${value#"${value%%[![:space:]]*}"}"
60
61 # remove trailing whitespace characters
62 value="${value%"${value##*[![:space:]]}"}"
63
64 print "${value}"
65}
66
1848564d
MT
67# Print a pretty error message
68function error() {
fcbf6823 69 echo -e " ${CLR_RED_B}ERROR${CLR_RESET} : $@" >&2
1848564d
MT
70}
71
1b7a1578 72function error_log() {
1b7a1578
MT
73 log ERROR "$@"
74}
75
1848564d
MT
76# Print a pretty warn message
77function warning() {
fcbf6823 78 echo -e " ${CLR_YELLOW_B}WARNING${CLR_RESET}: $@" >&2
1848564d
MT
79}
80
1b7a1578 81function warning_log() {
1b7a1578
MT
82 log WARNING "$@"
83}
84
e726ef8d
MT
85# The next three functions are kept for backwards
86# compatibility. The need to be dropped at some time.
1848564d 87function listsort() {
e726ef8d 88 list_sort $@
1848564d
MT
89}
90
711ffac1 91function listmatch() {
e726ef8d 92 list_match $@
711ffac1
MT
93}
94
95function listlength() {
e726ef8d 96 list_length $@
711ffac1
MT
97}
98
1848564d
MT
99# Speedup function to avoid a call of the basename binary
100function basename() {
101 echo "${1##*/}"
102}
103
e5651e17
MT
104function format() {
105 local key=${1}
106 assert isset key
107
108 local format=${2}
109 assert isset format
110
111 shift 2
112
113 printf -v "${key}" "${format}" "$@"
114}
115
b79ad79b
MT
116function assign() {
117 local key=${1}
118 assert isset key
119 shift
120
e5651e17 121 format "${key}" "%s" "$@"
b79ad79b
MT
122}
123
124function fread() {
125 local file=${1}
126 assert isset file
127
128 [ -r "${file}" ] || return ${EXIT_ERROR}
129
130 print "$(<${file})"
131}
132
133function fwrite() {
134 local file=${1}
135 assert isset file
136 shift
137
138 print "%s" "$@" >> ${file}
139}
140
1848564d
MT
141function enabled() {
142 local param=${1}
143
e726ef8d 144 list_match "${!param}" yes on true 1
1848564d
MT
145}
146
147function mac_generate() {
790b7ec9
MT
148 # Get a bunch of random hex digits
149 # and remove all dashes from the input.
150 local random=$(</proc/sys/kernel/random/uuid)
151 random=${random//-/}
152 assert isset random
1848564d
MT
153
154 local output
790b7ec9
MT
155
156 local i o
157 for i in $(seq 0 5); do
158 o="0x${random:0:2}"
159 random="${random:2:${#random}}"
160
161 case "${i}" in
162 0)
163 # Remove multicast bit
164 # and set address is software assigned
165 o=$(( ${o} & 0xfe ))
166 o=$(( ${o} | 0x02 ))
167
168 printf -v output "%02x" "${o}"
169 ;;
170 *)
171 printf -v output "%s:%02x" "${output}" "${o}"
172 ;;
173 esac
1848564d
MT
174 done
175
176 # Check if output is valid
177 assert mac_is_valid ${output}
178
790b7ec9 179 echo "${output}"
1848564d
MT
180}
181
18b43372
MT
182function mac_format() {
183 local mac=${1}
48bc31eb 184 assert isset mac
18b43372 185
48bc31eb
MT
186 # Remove all colons and make the rest lowercase.
187 mac=${mac//:/}
188 mac=${mac,,}
18b43372 189
48bc31eb 190 local output
18b43372
MT
191 if [ "${#mac}" = "12" ]; then
192 # Add colons (:) to mac address
193 output=${mac:0:2}
194 local i
195 for i in 2 4 6 8 10; do
196 output="${output}:${mac:${i}:2}"
197 done
48bc31eb
MT
198 else
199 output=${mac}
18b43372
MT
200 fi
201
202 assert mac_is_valid ${output}
203
48bc31eb 204 print "${output}"
18b43372
MT
205}
206
1848564d
MT
207function mac_is_valid() {
208 local mac=${1}
209
210 [[ ${mac} =~ ^([0-9a-f]{2}\:){5}[0-9a-f]{2}$ ]]
211}
212
213function uuid() {
de543653 214 echo $(</proc/sys/kernel/random/uuid)
1848564d
MT
215}
216
217function isset() {
218 local var=${1}
219
220 [ -n "${!var}" ]
221}
222
223function isoneof() {
224 local var=${!1}
225 shift
226
e726ef8d 227 list_match "${var}" "$@"
1848564d
MT
228}
229
230function isbool() {
231 local var=${1}
232
233 isoneof ${var} 0 1 no yes on off
234}
235
236function isinteger() {
237 local var=${!1}
238
239 [[ ${var} =~ ^[0-9]+$ ]]
240}
241
242function ismac() {
243 local mac=${!1}
244
245 mac_is_valid ${mac}
246}
247
fef4edaf
MT
248function isipaddress() {
249 local addr=${!1}
250
251 ip_is_valid ${addr}
252}
253
711ffac1
MT
254function backtrace() {
255 local start=1
256
257 echo # Empty line
258 error_log "Backtrace (most recent call in first line):"
259
04608623 260 local i source
711ffac1
MT
261 for i in $(seq ${start} ${#BASH_SOURCE[*]}); do
262 [ -z "${FUNCNAME[${i}]}" ] && continue
263 [ "${FUNCNAME[${i}]}" == "main" ] && continue
264
04608623
MT
265 source=${BASH_SOURCE[$(( ${i} + 1 ))]}
266 error_log " $(printf "%20s" "'${FUNCNAME[${i}]}'") called from ${source:-<shell>}:${BASH_LINENO[${i}]}"
711ffac1
MT
267 done
268}
269
1848564d
MT
270function assert() {
271 local assertion="$@"
272
273 if ! ${assertion}; then
4c670d7c 274 error_log "Assertion '${assertion}' failed."
711ffac1 275 backtrace
cfbe0802 276 exit ${EXIT_ERROR_ASSERT}
1848564d
MT
277 fi
278
279 return ${EXIT_OK}
280}
cad8bd85 281
b0b2f995
MT
282# This function checks, if the given argument is an assert error
283# exit code. If this is the case, the script will halt immediately.
284function assert_check_retval() {
285 local ret=${1}
286
287 if [ ${ret} -eq ${EXIT_ERROR_ASSERT} ]; then
288 exit ${EXIT_ERROR_ASSERT}
289 fi
290
291 return ${ret}
292}
293
711ffac1
MT
294function exec_cmd() {
295 local cmd=$@
296
297 log DEBUG "Running command: ${cmd}"
298
b816e04b 299 DEBUG=${DEBUG} \
8c63fa13
MT
300 LOG_DISABLE_STDOUT="${LOG_DISABLE_STDOUT}" \
301 LOG_FACILITY="${LOG_FACILITY}" \
b816e04b 302 ${SHELL} ${cmd}
711ffac1
MT
303 local ret=$?
304
305 #log DEBUG "Returned with code '${ret}'"
306
307 if [ ${ret} -eq ${EXIT_ERROR_ASSERT} ]; then
308 error_log "Stopping parent process due to assertion error in child process: ${cmd}"
309 exit ${EXIT_ERROR_ASSERT}
310 fi
311
312 return ${ret}
313}
314
b816e04b
MT
315function cmd() {
316 local cmd=$@
317
318 log DEBUG "Running command: ${cmd}"
319
320 ${cmd}
321 local ret=$?
322
323 log DEBUG "Returned with code '${ret}'"
324
325 return ${ret}
326}
327
98146c00
MT
328function cmd_quiet() {
329 cmd $@ &>/dev/null
3efecbb3
MT
330}
331
f80ce052
MT
332function cmd_exec() {
333 local cmd=$@
334
335 log DEBUG "Exec'ing command: ${cmd}"
336
337 exec ${cmd}
338
339 log ERROR "Could not exec-ute: ${cmd}"
340 exit ${EXIT_ERROR}
341}
342
2181765d
MT
343function cmd_not_implemented() {
344 assert false "not implemented"
345}
346
3efecbb3
MT
347function seq() {
348 if [ $# -eq 2 ]; then
349 eval echo {${1}..${2}}
350 elif [ $# -eq 3 ]; then
351 eval echo {${1}..${3}..${2}}
352 fi
353}
354
76e6cd51
MT
355function which() {
356 type -P $@
357}
358
fe52c5e0
MT
359# Prints the number of seconds since epoch.
360function timestamp() {
361 date -u "+%s"
362}
363
d82cf370
MT
364function beautify_time() {
365 local value=${1}
366
367 local unit
368 local limit
369 for unit in s m h d w; do
370 case "${unit}" in
371 s|m|h)
372 limit=60
373 ;;
374 d)
375 limit=24
376 ;;
377 w)
378 limit=7
379 ;;
380 esac
381
382 [ ${value} -lt ${limit} ] && break
383
384 value=$(( ${value} / ${limit} ))
385 done
386
387 echo "${value}${unit}"
388}
711ffac1
MT
389
390function beautify_bytes() {
391 local value=${1}
392
393 local unit
394 local limit=1024
395 for unit in B k M G T; do
396 [ ${value} -lt ${limit} ] && break
397 value=$(( ${value} / ${limit} ))
398 done
399
400 echo "${value}${unit}"
401}
943e3f7e
MT
402
403function module_load() {
404 local module=${1}
405
406 if ! grep -q "^${module}" /proc/modules; then
407 log DEBUG "Loading module '${module}'."
408 modprobe ${module}
409 fi
410}
6b3f9c85
MT
411
412function binary_exists() {
413 local binary=${1}
414
415 if [ -n "$(type -p ${binary})" ]; then
416 return ${EXIT_OK}
417 fi
418
419 return ${EXIT_ERROR}
420}
d76f5107
MT
421
422function process_kill() {
423 local process=${1}
424
425 if ! isinteger process; then
426 process=$(pidof ${process})
427 fi
428
429 local pid
430 local sig
431 for pid in ${process}; do
432 for sig in 15 9; do
433 [ -d "/proc/${pid}" ] || break
434
435 kill -${sig} ${pid}
436 sleep 1
437 done
438 done
439}
feb76eaf
MT
440
441function dec() {
442 local hex=${1}
443
444 if [ "${hex:0:2}" != "0x" ]; then
445 hex="0x${hex}"
446 fi
447
448 printf "%d\n" "${hex}"
449}
3a7fef62
MT
450
451function network_is_running() {
452 # Check, if the network service is running.
453 service_is_active network
454}
f80ce052
MT
455
456function contains_spaces() {
457 local var="$@"
458
459 # Eliminate spaces.
460 local var2=${var// /}
461
462 if [ ${#var} -ne ${#var2} ]; then
463 return ${EXIT_TRUE}
464 fi
465
466 return ${EXIT_FALSE}
467}